//################################################
// Single Speed Fans - Nolimits 2 RollerCoaster
// 12/16/2023
// Started by Hans van der Meer
//################################################

//**************** Fans *****************
#define Fan1_Pin 9 //FAN output pin1

//************** Variables **************p
int bufferArray[4]; // 4 digits comming in from the serialport
int Speed;

//**************** Setup ****************
void setup() {
  pinMode(Fan1_Pin, OUTPUT); 
  
   
  //Start Serial
  Serial.begin(115200); // opens serial port, sets data rate to 115200 bps, make sure that you setup the Interface in Simtools 3 in the correct way
  // open Game Dash Setup Tab
  // Selected Plugin Serial
  // Select comport, 115200,8,none,1
  // Save
}

//**************** Loop *****************
void loop(){
   if (Serial.available() >= 4) { //if 4 bits available in the Serial buffer...     
      bufferArray[0] = Serial.read();    
      if (bufferArray[0]  == 'S'){             // this is the first Value sent by the Serial output, S=83 in the ASCII Table
        bufferArray[1] = Serial.read();        // Read the 1st byte
        bufferArray[2] = Serial.read();        // Read the 2nd Byte
        bufferArray[3] = Serial.read();        // Read the 3rd Byte
              
     
            Speed = ((bufferArray[1] -48)*100) + ((bufferArray[2]-48) *10) + ((bufferArray[3] -48)*1); //The Bytes are in Decimal ASCCII Format
            //this piece of code is to check if the right values are calculated, you can test it by sending S255 via the Serial monitor to the comport. The fan should blow at full speed. Sent S000 to stop it.
             Serial.print("I received: ");
             Serial.println(bufferArray[0], DEC); //83 is S in the ASCII table
             Serial.println((bufferArray[1]-48)*100, DEC); // If the value sent from the Game Dash is 255 than the 1st byte is 50. 50-48=2*100= 200
             Serial.println((bufferArray[2]-48)*10, DEC);  // If the value sent from the Game Dash is 255 than the 2nd byte is 53. 53-48=5*10= 50
             Serial.println((bufferArray[3]-48)*1, DEC);   // If the value sent from the Game Dash is 255 than the 3rd byte is 53. 50-48=5*1= 5
             //200+50+5=255 this valu is sent to Fan_Pin1
    Serial.println(Speed, DEC);
            analogWrite(Fan1_Pin, Speed);
         }    
   }   
}
      
   

